Bug 1475750 - Review Request: golang-bazil-fuse - Go library for writing FUSE userspace filesystems
Review Request: golang-bazil-fuse - Go library for writing FUSE userspace fil...
Status: CLOSED ERRATA
Product: Fedora
Classification: Fedora
Component: Package Review (Show other bugs)
rawhide
Unspecified Unspecified
unspecified Severity unspecified
: ---
: ---
Assigned To: Scott Talbert
Fedora Extras Quality Assurance
:
Depends On:
Blocks: 1473314
  Show dependency treegraph
 
Reported: 2017-07-27 05:14 EDT by Robert-André Mauchin
Modified: 2017-09-30 02:13 EDT (History)
2 users (show)

See Also:
Fixed In Version:
Doc Type: If docs needed, set a value
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2017-09-10 22:25:15 EDT
Type: Bug
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---
swt: fedora‑review+


Attachments (Terms of Use)

  None (edit)
Description Robert-André Mauchin 2017-07-27 05:14:51 EDT
Spec URL: https://github.com/eclipseo/packaging/blob/ec6f7c0/golang-bazil-fuse.spec
SRPM: https://koji.fedoraproject.org/koji/taskinfo?taskID=20795875
Koji build: https://koji.fedoraproject.org/koji/taskinfo?taskID=20795875

Fedora Account System Username: eclipseo

This is one of the many build dependencies for rclone, bug #1473314, handling FUSE in Go.

Note that the %check has been explicitly deactivated in this SPEC because it requires loading a module (fuse.ko).

I am still looking for a sponsorship, please consider me.

Thank you.
Comment 5 Scott Talbert 2017-08-26 10:11:28 EDT
Taking this since you did one of my packages.  :)  I'm not familiar with Fedora go packaging, but I am familiar with this particular go library.
Comment 6 Scott Talbert 2017-08-27 21:49:49 EDT
Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated
[ ] = Manual review needed


Issues:
=======
- What is the purpose of the unit-test-devel subpackage?  I'm not sure I
  understand the usefulness of packaging the unit tests.
- Package does not contain duplicates in %files.
  Note: warning: File listed twice: /usr/share/gocode/src/bazil.org/fuse
  See: http://fedoraproject.org/wiki/Packaging/Guidelines#DuplicateFiles
- I believe the license field should include MIT as well (see the section
  in LICENSE that refers to fuse.go which appears to be MIT license).
- Technically, the package doesn't require the golang package, which owns
  /usr/share/gocode and /usr/share/gocode/src, but I don't know if this
  is a common omission in golang packaging?
- Package doesn't own /usr/share/gocode/src/bazil.org directory.


===== MUST items =====

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[!]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses
     found: "BSD (3 clause)", "BSD (2 clause)", "Unknown or generated". 78
     files have unknown license. Detailed output of licensecheck in
     /home/talbert/fedora-review/1475750-golang-bazil-fuse/licensecheck.txt
[x]: License file installed when any subpackage combination is installed.
[!]: Package requires other packages for directories it uses.
     Note: No known owner of /usr/share/gocode/src/bazil.org
[!]: Package must own all directories that it creates.
     Note: Directories without known owners: /usr/share/gocode/src,
     /usr/share/gocode, /usr/share/gocode/src/bazil.org
[x]: %build honors applicable compiler flags or justifies otherwise.
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[x]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory
     names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[-]: Useful -debuginfo package or justification otherwise.
[x]: Package is not known to require an ExcludeArch tag.
[x]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 20480 bytes in 2 files.
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least
     one supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: If (and only if) the source package includes the text of the
     license(s) in its own file, then that file, containing the text of the
     license(s) for the package is included in %license.
[x]: Package does not own files or directories owned by other packages.
[x]: All build dependencies are listed in BuildRequires, except for any
     that are listed in the exceptions section of Packaging Guidelines.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Dist tag is present.
[x]: Permissions on files are set properly.
[x]: Package use %makeinstall only when make install DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package does not use a name that already exists.
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as
     provided in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

===== SHOULD items =====

Generic:
[x]: If the source package does not include license text(s) as a separate
     file from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[x]: Fully versioned dependency in subpackages if applicable.
     Note: No Requires: %{name}%{?_isa} = %{version}-%{release} in golang-
     bazil-fuse-devel , golang-bazil-fuse-unit-test-devel
[?]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[-]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[!]: %check is present and all tests pass.
[?]: Packages should try to preserve timestamps of original installed
     files.
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: SourceX is a working URL.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[x]: Large data in /usr/share should live in a noarch subpackage if package
     is arched.
[x]: Spec file according to URL is the same as in SRPM.


Rpmlint
-------
Checking: golang-bazil-fuse-devel-0-0.1.20160811.git371fbbd.fc27.noarch.rpm
          golang-bazil-fuse-unit-test-devel-0-0.1.20160811.git371fbbd.fc27.x86_64.rpm
          golang-bazil-fuse-0-0.1.20160811.git371fbbd.fc27.src.rpm
golang-bazil-fuse-devel.noarch: W: spelling-error Summary(en_US) userspace -> user space, user-space, users pace
golang-bazil-fuse-devel.noarch: W: spelling-error Summary(en_US) filesystems -> file systems, file-systems, ecosystems
golang-bazil-fuse-devel.noarch: W: spelling-error %description -l en_US userspace -> user space, user-space, users pace
golang-bazil-fuse-devel.noarch: W: spelling-error %description -l en_US filesystems -> file systems, file-systems, ecosystems
golang-bazil-fuse.src: W: spelling-error Summary(en_US) userspace -> user space, user-space, users pace
golang-bazil-fuse.src: W: spelling-error Summary(en_US) filesystems -> file systems, file-systems, ecosystems
golang-bazil-fuse.src: W: spelling-error %description -l en_US userspace -> user space, user-space, users pace
golang-bazil-fuse.src: W: spelling-error %description -l en_US filesystems -> file systems, file-systems, ecosystems
3 packages and 0 specfiles checked; 0 errors, 8 warnings.




Rpmlint (installed packages)
----------------------------
sh: /usr/bin/python: No such file or directory
golang-bazil-fuse-devel.noarch: W: spelling-error Summary(en_US) userspace -> user space, user-space, users pace
golang-bazil-fuse-devel.noarch: W: spelling-error Summary(en_US) filesystems -> file systems, file-systems, ecosystems
golang-bazil-fuse-devel.noarch: W: spelling-error %description -l en_US userspace -> user space, user-space, users pace
golang-bazil-fuse-devel.noarch: W: spelling-error %description -l en_US filesystems -> file systems, file-systems, ecosystems
2 packages and 0 specfiles checked; 0 errors, 4 warnings.



Requires
--------
golang-bazil-fuse-unit-test-devel (rpmlib, GLIBC filtered):
    golang-bazil-fuse-devel

golang-bazil-fuse-devel (rpmlib, GLIBC filtered):
    golang(golang.org/x/net/context)
    golang(golang.org/x/sys/unix)



Provides
--------
golang-bazil-fuse-unit-test-devel:
    golang-bazil-fuse-unit-test-devel
    golang-bazil-fuse-unit-test-devel(x86-64)

golang-bazil-fuse-devel:
    golang(bazil.org/fuse)
    golang(bazil.org/fuse/fs)
    golang(bazil.org/fuse/fs/bench)
    golang(bazil.org/fuse/fs/fstestutil)
    golang(bazil.org/fuse/fs/fstestutil/record)
    golang(bazil.org/fuse/fuseutil)
    golang(bazil.org/fuse/syscallx)
    golang-bazil-fuse-devel



Source checksums
----------------
https://github.com/bazil/fuse/archive/371fbbdaa8987b715bdd21d6adc4c9b20155f748/fuse-371fbbd.tar.gz :
  CHECKSUM(SHA256) this package     : c71cc848a10d0bdbd2fb9254cbe49f1f9e73c076335c92f16981425a90f3ded9
  CHECKSUM(SHA256) upstream package : c71cc848a10d0bdbd2fb9254cbe49f1f9e73c076335c92f16981425a90f3ded9


Generated by fedora-review 0.6.1 (f03e4e7) last change: 2016-05-02
Command line :/usr/bin/fedora-review -b 1475750 -m fedora-rawhide-x86_64
Buildroot used: fedora-rawhide-x86_64
Active plugins: Generic, Shell-api
Disabled plugins: Java, C/C++, Python, fonts, SugarActivity, Ocaml, Perl, Haskell, R, PHP
Disabled flags: EXARCH, DISTTAG, EPEL5, BATCH, EPEL6
Comment 7 Robert-André Mauchin 2017-08-28 05:47:21 EDT
Thanks for your review.

> - What is the purpose of the unit-test-devel subpackage?  I'm not sure I
  understand the usefulness of packaging the unit tests.

It is how Golang libraries are supposed to be packaged. See https://koji.fedoraproject.org/koji/search?match=glob&type=rpm&terms=*unit-test-devel* All of these Golang libraries SPECs are generated by Gofed, the script recommended in Golang Draft Guidelines.

> - Package does not contain duplicates in %files.
  Note: warning: File listed twice: /usr/share/gocode/src/bazil.org/fuse
  See: http://fedoraproject.org/wiki/Packaging/Guidelines#DuplicateFiles

Removed.

> - I believe the license field should include MIT as well (see the section
  in LICENSE that refers to fuse.go which appears to be MIT license).

I've added the reference to fuse.go under MIT.

> - Package doesn't own /usr/share/gocode/src/bazil.org directory.

No, because this directory is not specific to this package, it is shared with other Go project from Bazil. If I were to package golang-bazil-zipfs for example, I would also use /usr/share/gocode/src/bazil.org. The only specific directory are the ones one level below, for example /usr/share/gocode/src/bazil.org/fuse or /usr/share/gocode/src/bazil.org/zipfs


SPEC URL: https://copr-be.cloud.fedoraproject.org/results/eclipseo/rclone/fedora-rawhide-x86_64/00594632-golang-bazil-fuse/golang-bazil-fuse.spec
SRPM URL: https://copr-be.cloud.fedoraproject.org/results/eclipseo/rclone/fedora-rawhide-x86_64/00594632-golang-bazil-fuse/golang-bazil-fuse-0-0.1.20160811.git371fbbd.fc28.src.rpm
Comment 8 Scott Talbert 2017-08-28 22:55:45 EDT
(In reply to Robert-André Mauchin from comment #7)
> > - What is the purpose of the unit-test-devel subpackage?  I'm not sure I
>   understand the usefulness of packaging the unit tests.
> 
> It is how Golang libraries are supposed to be packaged. See
> https://koji.fedoraproject.org/koji/search?match=glob&type=rpm&terms=*unit-
> test-devel* All of these Golang libraries SPECs are generated by Gofed, the
> script recommended in Golang Draft Guidelines.

Strange.  I just don't see the purpose, but OK.

> > - Package doesn't own /usr/share/gocode/src/bazil.org directory.
> 
> No, because this directory is not specific to this package, it is shared
> with other Go project from Bazil. If I were to package golang-bazil-zipfs
> for example, I would also use /usr/share/gocode/src/bazil.org. The only
> specific directory are the ones one level below, for example
> /usr/share/gocode/src/bazil.org/fuse or /usr/share/gocode/src/bazil.org/zipfs

I see your point, but some package has to own the bazil.org directory.  It appears that the 'golang' package owns the github.com directory[1] and a few others, so probably it should own the bazil.org directory too?  Perhaps you can file a bug or submit a PR for that?
[1] https://src.fedoraproject.org/rpms/golang/blob/master/f/golang.spec#_407
Comment 10 Scott Talbert 2017-08-29 22:51:59 EDT
(In reply to Robert-André Mauchin from comment #9)
> All righty then, I've fixed it:

Well, I think technically it probably would be better for 'golang' to own it, in case, like you said, if someone packaged zipfs.  But this is fine for now.

Approved.  Thanks for your work.
Comment 11 Gwyn Ciesla 2017-09-01 08:51:46 EDT
(fedrepo-req-admin):  The Pagure repository was created at https://src.fedoraproject.org/rpms/golang-bazil-fuse
Comment 12 Fedora Update System 2017-09-02 03:59:42 EDT
golang-bazil-fuse-0-0.1.20160811git371fbbd.fc27 has been submitted as an update to Fedora 27. https://bodhi.fedoraproject.org/updates/FEDORA-2017-8a5b7ede07
Comment 13 Fedora Update System 2017-09-02 04:00:18 EDT
golang-bazil-fuse-0-0.1.20160811git371fbbd.fc26 has been submitted as an update to Fedora 26. https://bodhi.fedoraproject.org/updates/FEDORA-2017-037c9c218a
Comment 14 Fedora Update System 2017-09-02 04:00:50 EDT
golang-bazil-fuse-0-0.1.20160811git371fbbd.fc25 has been submitted as an update to Fedora 25. https://bodhi.fedoraproject.org/updates/FEDORA-2017-7470f3d312
Comment 15 Fedora Update System 2017-09-03 01:24:45 EDT
golang-bazil-fuse-0-0.1.20160811git371fbbd.fc26 has been pushed to the Fedora 26 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2017-037c9c218a
Comment 16 Fedora Update System 2017-09-03 02:25:57 EDT
golang-bazil-fuse-0-0.1.20160811git371fbbd.fc25 has been pushed to the Fedora 25 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2017-7470f3d312
Comment 17 Fedora Update System 2017-09-03 15:55:07 EDT
golang-bazil-fuse-0-0.1.20160811git371fbbd.fc27 has been pushed to the Fedora 27 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2017-8a5b7ede07
Comment 18 Fedora Update System 2017-09-10 22:25:15 EDT
golang-bazil-fuse-0-0.1.20160811git371fbbd.fc25 has been pushed to the Fedora 25 stable repository. If problems still persist, please make note of it in this bug report.
Comment 19 Fedora Update System 2017-09-11 00:20:45 EDT
golang-bazil-fuse-0-0.1.20160811git371fbbd.fc26 has been pushed to the Fedora 26 stable repository. If problems still persist, please make note of it in this bug report.
Comment 20 Fedora Update System 2017-09-30 02:13:13 EDT
golang-bazil-fuse-0-0.1.20160811git371fbbd.fc27 has been pushed to the Fedora 27 stable repository. If problems still persist, please make note of it in this bug report.

Note You need to log in before you can comment on or make changes to this bug.